import math
import Conf
import random
from Bloc import Bloc
from StepBloc import StepBloc
from GroupCircle import GroupCircle
from Collection import Collection
'''
Created on 24 mars 2019

@author: invite
'''

class BaseWay(object):
    '''
    classdocs
    '''


    def __init__(self, base):
        '''
        Constructor
        '''
        self.base=base
        random.seed()
        self.c=[]
        
        for o in StepBloc(base).getList():
            self.c.append(o)
        
        pxb=self.base.getPx()
        pyb=self.base.getPy()
        pzb=self.base.getPz()
        sxb=self.base.getSx()
        syb=self.base.getSy()
        szb=self.base.getSz()
        rotationb=self.base.getRotation()
        
        rand=random.random()
        #rand=0.3
        if rand < 0.35:
            #***
            # circle
            #***
            
            if sxb>syb:
                rayon=sxb*2
            else:
                rayon=syb*2
            
            rayon+=random.randint(0,Conf.stepLong)
                
            nbMax=((2*math.pi*rayon)/(math.sqrt(2)* \
                (Conf.circleSizeXmax+Conf.circleSizeYmax-Conf.circleSizeXmin-Conf.circleSizeYmin)/2))-2
            if nbMax>8:
                nb=random.randint(8,int(nbMax))
            else:
                nb=8
            
            sizeX=random.randint(Conf.circleSizeXmin,Conf.circleSizeXmax)
            sizeY=random.randint(Conf.circleSizeYmin,Conf.circleSizeYmax)
            z=pzb+szb
            
            if random.random() < Conf.ratioTailleFixe:
                sizeZ=random.randint(z-Conf.stepHight,z)
                c=Collection(nb=nb,type="box",sizeX=sizeX,sizeY=sizeY,sizeZ=sizeZ)
            else:
                c=Collection(nb=nb,type="box", \
                         sizeXmin=Conf.circleSizeXmin,sizeYmin=Conf.circleSizeYmin,sizeZmin=Conf.circleSizeZmin, \
                         sizeXmax=sizeX,sizeYmax=sizeY,sizeZmax=z+Conf.stepHight)
            
            for o in GroupCircle(c,rayon=rayon,shX=pxb,shY=pyb).getList():             
                self.c.append(o)
            
            nbWay=1
        
        
        #***    
        # random gateways
        #***
        
        elif rand <=1 :
            nbWay=random.randint(Conf.baseWayMin,Conf.baseWayMax)
            

                

        
        #***    
        # square gateways
        #***
        """
        elif rand <= 1 :
            
            if sxb > syb :
                syMin = sxb + 10
            else:
                syMin = syb + 10
                
            sx=random.randint(Conf.baseWaySxMin,Conf.baseWaySxMax)
            sy=random.randint(syMin,Conf.baseWaySyMax)
            
            adjacent=syb+sx
            opose=sy-sxb
            hyp=math.sqrt((adjacent**2)+(opose**2))
            
            
            #90
            boxRad=(self.addAngle(rotationb,90)*math.pi)/180
            nextHopRad=math.atan(adjacent/opose)
            px,py=self.getNextHop(pxb,pyb,hyp,nextHopRad)
            
            self.c.append(Bloc(sx=sx,sy=sy,sz=Conf.baseWaySz,px=px,py=py,pz=pzb, \
                              type="box",rotation=boxRad*(180/math.pi),c=self.c))
            
            #180
            boxRad=(self.addAngle(rotationb,180)*math.pi)/180
            px,py=self.getNextHop(pxb,pyb,hyp,nextHopRad+math.pi)
            
            #self.c.append(Bloc(sx=sx,sy=sy,sz=Conf.baseWaySz,px=px,py=py,pz=pzb, \
             #                 type="box",rotation=boxRad*(180/math.pi),c=self.c))
            
            
            
            
            #if pzb+sxb > Conf.stepHight:
            #    for o in StepBloc(b).getList():
            #        self.c.append(o)   
        """
        
        
        #***
        # ajout des rampes et de leurs acces
        #***
        for i in range(1,nbWay+1):
            sx=random.randint(Conf.baseWaySxMin,Conf.baseWaySxMax)
            sy=random.randint(Conf.baseWaySyMin,Conf.baseWaySyMax)
            
            
            #baseBorder=math.sqrt((self.base.getSx()**2)+(self.base.getSy()**2))
            baseBorder=(self.base.getSx()+self.base.getSy())/2
            #baseBorder=0
            rotation=random.uniform(135,405)
            if rotation > 360:
                rotation -= 360
            
            
            px,py=self.getNextHop(pxb,pyb,sy+baseBorder,(rotation*math.pi)/180)
            
            b=Bloc(sx=sx,sy=sy,sz=Conf.baseWaySz,px=px,py=py,pz=pzb, \
                              type="box",rotation=rotation,c=self.c)
            self.c.append(b)
            
            if pzb+szb > Conf.stepHight:
                for o in StepBloc(b).getList():
                    self.c.append(o)
                        

    def addAngle(self,d1,d2):
        d=d1+d2
        while d > 360:
            d-=360
        return d        
            

    def getNextHop(self,pxb,pyb,sy,rad):
        
        if rad>=0 or rad<(math.pi/2):
            px=pxb+(math.sin(rad)*sy)
            py=pyb-(math.cos(rad)*sy)
        elif rad>=(math.pi/2) or rad<math.pi:
            px=pxb-(math.cos(rad-(math.pi/2))*sy)
            py=pyb-(math.sin(rad-(math.pi/2))*sy)            
        elif rad>=math.pi or rad<(3*math.pi)/2:
            px=pxb-(math.sin(math.pi-rad)*sy)
            py=pyb+(math.cos(math.pi-rad)*sy)
        elif rad>=(3*math.pi)/2 or rad<=2*math.pi:
            px=pxb+(math.sin((2*math.pi)-rad)*sy)
            py=pyb+(math.cos((2*math.pi)-rad)*sy)
        else:
            print("BaseWay.getNextHop :angle "+str(rad)+" not in range")
            exit(1)
        
        return px,py

    
    def getList(self):
        return self.c
